/*
 * AUTOGEM.C
 *
 * Desk accessory GEM program launcher.
 *
 * by Alex Leavens
 * for Ron Sprunger, R+D Tech
 *
 * rev. 0.1042787
 *
 * Designed to be compiled with Mark Williams C compiler
 * compile with the following command line:
 *
 * cc -VGEMACC -o autogem.acc autgem.c
 *
 */

#include "osbind.h"
#include "define.h"
#include "gemdefs.h"
#include "obdefs.h"

extern int gl_apid;

int     handle;         /* virtual workstation handle */

int     msgbuff[8];     /* event message buffer */

int     contrl[12];
int     intin[128];
int     ptsin[128];
int     intout[128];
int     ptsout[128];    /* storage wasted for idiotic bindings */

int work_in[11];        /* Input to GSX parameter array */
int work_out[57];       /* Output from GSX parameter array */
int pxyarray[10];       /* input point array */

main()
{
        int event, msgbuff[8], dummy;
        int handle, charw, charh, boxw, boxh;
        int menu_id, i;

/* Set the system up to do GEM calls*/


        appl_init();
        /* Get the handle of the desktop */

        handle = graf_handle(&charw,&charh,&boxw,&boxh);
	menu_id = menu_register(gl_apid,"  Auto Gem");

/* wait for the timer to count down... */

        evnt_timer(1000,0);

/* Now execute a GEM based program.  Stick the name of the GEM */
/* program you want to execute in here.  Note that some GEM */
/* programs are written so that they don't work via this method */
/* (1st word springs to mind), although a properly written GEM */
/* program should have _no trouble_ dealing with this */

        event = Pexec(0, "linedemo.prg", "", "");
        if (event < 0)
        {
            i = form_alert(1, "[3][ERROR! Program cannot be loaded. ][ Downer...
 ]");
        }

loop_for:

	while(1)
        {
          event = evnt_multi(MU_MESAG,
                  1,1,1,
                  0,0,0,0,0,
                  0,0,0,0,0,
                  msgbuff,
                  0,0,
                  &dummy, &dummy, &dummy,
                  &dummy, &dummy, &dummy);

          if (event & MU_MESAG)
          {
              switch(msgbuff[0]){
                    case AC_OPEN:
                        i = form_alert(1, "[1][AutoGem|by Alex Leavens][ Hmmm...
 ]");
                        break;
                    default:
                        break;
              }
   }
        }
        goto loop_for;

}
