;
;Program Equates
;
strssp  =       0               ;RESET stack pointer
gemdos  =       1
GEM     =       2
strvec  =       4               ;RESET vector
xbios   =       14
ob_ST   =       10              ;Offset to Object States
NUM_OBS =       16              ;Number of OBJECTs in tree
ob_SI   =       24              ;Size of object record
AC_Open =       40              ;Message from GEM to open Accessary
memval  =       $420            ;Memory Validation Location
f_ver   =       $444            ;Floppy Verify
;
; Object type equates
;
G_BOX           =       20
G_TEXT          =       21
G_BOXTEXT       =       22
G_IMAGE         =       23
G_PROGDEF       =       24
G_IBOX          =       25
G_BUTTON        =       26
G_BOXCHAR       =       27
G_STRING        =       28
G_FTEXT         =       29
G_FBOXTEXT      =       30
G_ICON          =       31
G_TITLE         =       32
;
; Object flag equates
;
NONE            =       $00
SELECTABLE      =       $01
DEFAULT         =       $02
EXIT            =       $04
EDITABLE        =       $08
RBUTTON         =       $10
LASTOB          =       $20
TOUCHEXIT       =       $40
HIDETREE        =       $80
INDIRECT        =       $0100
;
; Object status equates
;
NORMAL          =       $00
SELECTED        =       $01
CROSSED         =       $02
CHECKED         =       $04
DISABLED        =       $08
OUTLINED        =       $10
SHADOWED        =       $20
;
;Object index equates
;
WARMLY  =        6
COLDLY  =        7
NEVER   =        8
ON      =       12
OFF     =       13
OKAY    =       14
CANCEL  =       15
;
;Start Of Program
;
        text
destry: lea     resend,sp       ;Set up Internal Stack Pointer
        bsr     AES             ;Open application and get ID
        move.w  INTOUT,AP_ID
        clr.w   INTIN           ;Get size of GEM's desktop
        move.w  #4,INTIN+2
        move.l  #w_get,AESPB
        bsr     AES
        move.w  INTOUT,GEM_xpos
        move.w  INTOUT+2,GEM_ypos
        move.w  INTOUT+6,GEM_wpos
        move.w  INTOUT+8,GEM_hpos
        moveq   #NUM_OBS-1,D5   ;FIX objects in dialog box tree for
        move.l  #r_obfx,AESPB   ;  current resolution
        move.l  #resbox,ADDRIN
des010: move.w  D5,INTIN
        bsr     AES
        dbra    D5,des010
        move.w  AP_ID,INTIN     ;Register accessary in menu
        move.l  #pname,ADDRIN
        move.l  #m_regi,AESPB
        bsr     AES
        move.w  INTOUT,menuid   ;Save menu id
        bge     res000
des020: move.l  #msgbuf,ADDRIN  ;Not able to register accessary
        move.l  #e_mesa,AESPB   ;  then return to GEM always
        bsr     AES
        bra     des020
res000: bsr     go_sup          ;When first starting, clear floppy
        clr.w   f_ver           ;  write verify flag
        bsr     go_use
res010: move.l  #msgbuf,ADDRIN  ;Loop back to GEM waiting for message
        move.l  #e_mesa,AESPB   ;  to open accessary
        bsr     AES
        move.w  msgbuf,D0       ;  to open accessary
        cmpi.w  #AC_Open,D0
        bne     res010
        move.w  msgbuf+8,D0     ;If open message received, make sure its
        move.w  menuid,D1       ;  for our menu listing only.
        cmp.w   D1,D0
        bne     res010
        move.w  #4,-(sp)        ;GETREZ - find screen resolution and
        trap    #xbios          ;  display DIALOG BOX for medium and
        addq.l  #2,sp           ;  high, ALERT BOX for low
        cmpi.w  #1,D0
        blt     res070
        bgt     res013          ;Reset expanding box height for
        move.w  #8,f_lith       ;  resolution
        bra     res017
res013: move.w  #16,f_lith
res017: bsr     go_sup          ;Enter SUPER mode and set the states
        move.l  #resbox,A0      ;  of all of the objects in the tree
        andi.w  #$FE,WARMLY*ob_SI+ob_ST(A0)
        andi.w  #$FE,COLDLY*ob_SI+ob_ST(A0)
        andi.w  #$FE,OKAY*ob_SI+ob_ST(A0)
        andi.w  #$FE,CANCEL*ob_SI+ob_ST(A0)
        ori.w   #SELECTED,NEVER*ob_SI+ob_ST(A0)
        tst.w   f_ver           ;Test floppy verify flag to set these states
        bne     res020          ;  properly
        andi.w  #$FE,ON*ob_SI+ob_ST(A0)
        ori.w   #SELECTED,OFF*ob_SI+ob_ST(A0)
        bra     res030
res020: ori.w   #SELECTED,ON*ob_SI+ob_ST(A0)
        andi.w  #$FE,OFF*ob_SI+ob_ST(A0)
res030: bsr     go_use          ;Go back to USER mode and show and do dialog
        move.w  #1,INTIN        ;Stop other window redraws
        move.l  #w_upda,AESPB
        bsr     AES
        move.l  #resbox,ADDRIN  ;FORM_Center
        move.l  #f_cntr,AESPB
        bsr     AES
        move.w  INTOUT+2,fo_cx
        move.w  INTOUT+4,fo_cy
        move.w  INTOUT+6,fo_cw
        move.w  INTOUT+8,fo_ch
        clr.w   INTIN           ;FORM_Dial #0 (SAVE MEMORY)
        move.w  f_little,INTIN+2
        move.w  f_little+2,INTIN+4
        move.w  f_little+4,INTIN+6
        move.w  f_little+6,INTIN+8
        move.w  fo_cx,INTIN+10
        move.w  fo_cy,INTIN+12
        move.w  fo_cw,INTIN+14
        move.w  fo_ch,INTIN+16
        move.l  #f_dial,AESPB
        bsr     AES
        move.w  #1,INTIN        ;FORM_Dial #1 (EXPAND)
        bsr     AES
        clr.w   INTIN           ;OBJC_Draw
        move.w  #8,INTIN+2
        move.w  GEM_xpos,INTIN+4
        move.w  GEM_ypos,INTIN+6
        move.w  GEM_wpos,INTIN+8
        move.w  GEM_hpos,INTIN+10
        move.l  #resbox,ADDRIN
        move.l  #o_draw,AESPB
        bsr     AES
        move.w  #-1,INTIN       ;FORM_Do
        move.l  #resbox,ADDRIN
        move.l  #f_do,AESPB
        bsr     AES
        move.w  INTOUT,D0
        cmpi.w  #OKAY,D0        ;Test if OK button was pressed to exit
        bne     res060          ;  dialog box
        bsr     go_sup          ;If so, then go to SUPER mode to make changes
        move.l  #resbox,A0      ;Setup pointer for test
        btst    #0,ON*ob_SI+ob_ST+1(A0)
        beq     res040
        move.w  #-1,f_ver       ;If ON set, then set floppy verify to -1
        bra     res050
res040: clr.w   f_ver           ;Otherwise clear the flag
res050: btst    #0,WARMLY*ob_SI+ob_ST+1(A0) ;Not test the reset buttons,
        bne     res100          ;  and jump to reset if necessary
        btst    #0,COLDLY*ob_SI+ob_ST+1(A0)
        bne     res200
        bsr     go_use          ;No reset, then go back to USER mode
res060: move.w  #2,INTIN        ;FORM_Dial #2 (SHRINK)
        move.w  f_little,INTIN+2
        move.w  f_little+2,INTIN+4
        move.w  f_little+4,INTIN+6
        move.w  f_little+6,INTIN+8
        move.w  fo_cx,INTIN+10
        move.w  fo_cy,INTIN+12
        move.w  fo_cw,INTIN+14
        move.w  fo_ch,INTIN+16
        move.l  #f_dial,AESPB
        bsr     AES
        move.w  #3,INTIN        ;FORM_Dial #3 (FREE MEMORY)
        bsr     AES
        clr.w   INTIN           ;Allow other windows to UPDATE
        move.l  #w_upda,AESPB
        bsr     AES
        bra     res010          ;  loop back to GEM
res070: move.w  #3,INTIN        ;Show ALERT box asking how to reset the
        move.l  #messtr,ADDRIN  ;  the computer -
        move.l  #f_alrt,AESPB   ;FORM_Alert
        bsr     AES
        move.w  INTOUT,D5
        cmpi.w  #3,D5
        beq     res010          ;     Button #3 - don't reset
        bsr     go_sup          ;Enter SUPER mode for restarts
        cmpi.w  #2,D5
        beq     res200          ;     Button #2 - COLD start
        cmpi.w #1,D5
        beq     res100          ;     Button #1 - WARM start
        bsr     go_use          ;Unexpected reply, go back to USER
        bra     res010          ;  mode and return to GEM
res100: move.l  strssp,sp       ;FOR WARM start just jump through the reset
        move.l  strvec,A0       ;  vector in the beginning of memory
        jmp     (A0)
res200: clr.l   memval          ;For COLD start memval must first be
        move.l  strssp,sp       ;  cleared before jumping through reset vector
        move.l  strvec,A0
        jmp     (A0)
AES:    move.l  #AESPB,D1
        move.w  #$C8,D0
        trap    #GEM
        rts
go_sup: clr.l   -(sp)
        move.w  #$20,-(sp)
        trap    #gemdos
        addq.l  #6,sp
        rts
go_use: move.l  D0,-(sp)
        move.w  #$20,-(sp)
        trap    #gemdos
        addq.l  #6,sp
        rts
;
; DATA Segment
;
        data
a_init:    dc.w 10,0,1,0,0
w_get:     dc.w 104,2,5,0,0
r_obfx:    dc.w 114,1,1,1,0
m_regi:    dc.w 35,1,1,1,0
e_mesa:    dc.w 23,0,1,1,0
w_upda:    dc.w 107,1,1,0,0
f_cntr:    dc.w 54,0,5,1,0
f_dial:    dc.w 51,9,1,1,0
o_draw:    dc.w 42,6,1,1,0
f_do:      dc.w 50,1,2,1,0
f_alrt:    dc.w 52,1,1,1,0
f_little:  dc.w 24,1,32
f_lith:    dc.w 16
fo_cx:     dc.w 0
fo_cy:     dc.w 0
fo_cw:     dc.w 0
fo_ch:     dc.w 0
GEM_xpos:  dc.w 0
GEM_ypos:  dc.w 0
GEM_wpos:  dc.w 0
GEM_hpos:  dc.w 0
GLOBAL:
APVERSION: dc.w 0
APCOUNT:   dc.w 0
AP_ID:     dc.w 0
APPRIVATE: dc.l 0
APPTREE:   dc.l 0
AP1RESV:   dc.l 0
AP2RESV:   dc.l 0
AP3RESV:   dc.l 0
AP4RESV:   dc.l 0
AESPB:     dc.l a_init
           dc.l GLOBAL
           dc.l INTIN
           dc.l INTOUT
           dc.l ADDRIN
           dc.l ADDROUT
;
;TEDINFO structures
;
tinfo1:    dc.l titms,null,null
           dc.w 3, 6, 2, $1180, 0, -2, 39, 1
tinfo2:    dc.l okayms,null,null
           dc.w 3, 6, 2, $1180, 0, -2, 7, 1
tinfo3:    dc.l cancms,null,null
           dc.w 3, 6, 2, $1180, 0, -3, 7, 1
;
;OBJECT TREE #0
;
resbox:    dc.w -1, 1, 15, G_BOX, NONE, SHADOWED
           dc.l $011133
           dc.w 0,0,60,15

           dc.w 2, -1, -1, G_BOXTEXT, NONE, SHADOWED
           dc.l tinfo1
           dc.w 9,1,41,2

           dc.w 9, 3, 8, G_BOX, NONE, SHADOWED
           dc.l $FF1112
           dc.w 2,4,35,7

           dc.w 4, -1, -1, G_STRING, NONE, NORMAL
           dc.l beg1ms
           dc.w 2,1,32,1

           dc.w 5, -1, -1, G_STRING, NONE, NORMAL
           dc.l beg2ms
           dc.w 2,2,32,1

           dc.w 6, -1, -1, G_STRING, NONE, NORMAL
           dc.l beg3ms
           dc.w 14,3,7,1

           dc.w 7, -1, -1, G_BUTTON, $11, SHADOWED
           dc.l warmms
           dc.w 2,5,8,1

           dc.w 8, -1, -1, G_BUTTON, $11, SHADOWED
           dc.l coldms
           dc.w 13,5,8,1

           dc.w 2, -1, -1, G_BUTTON, $11, SHADOWED
           dc.l nevms
           dc.w 24,5,8,1

           dc.w 14, 10, 13, G_BOX, NONE, SHADOWED
           dc.l $FF1112
           dc.w 40,4,18,7

           dc.w 11, -1, -1, G_STRING, NONE, NORMAL
           dc.l setms
           dc.w 1,1,16,1

           dc.w 12, -1, -1, G_STRING, NONE, NORMAL
           dc.l verms
           dc.w 6,2,6,1

           dc.w 13, -1, -1, G_BUTTON, $11, SHADOWED
           dc.l onms
           dc.w 1,4,7,2

           dc.w 9, -1, -1, G_BUTTON, $11, SHADOWED
           dc.l offms
           dc.w 10,4,7,2

           dc.w 15, -1, -1, G_BOXTEXT, $5, NORMAL
           dc.l tinfo2
           dc.w 18,12,8,2

           dc.w 0, -1, -1, G_BOXTEXT, $27, NORMAL
           dc.l tinfo3
           dc.w 34,12,8,2

           dc.l resbox
;
;Resource Strings
;
titms:     dc.b 'RESET COMPUTER and FLOPPY WRITE VERIFY',0
null:      dc.b 0
beg1ms:    dc.b 'How would you like to RESET your',0
beg2ms:    dc.b 'COMPUTER and destroy all of your',0
beg3ms:    dc.b 'work...',0
warmms:    dc.b 'WARMLY',0
coldms:    dc.b 'COLDLY',0
nevms:     dc.b 'NEVER',0
setms:     dc.b 'SET FLOPPY WRITE',0
verms:     dc.b 'VERIFY',0
onms:      dc.b 'ON',0
offms:     dc.b 'OFF',0
okayms:    dc.b ' OKAY ',0
cancms:    dc.b 'CANCEL',0
;
;OTHER Strings
;
pname:     dc.b    '  Reset Computer',0
messtr     dc.b    '[3][How do you want to reset|the computer and '
           dc.b    'destroy|all of your work...]'
           dc.b    '[WARMLY|COLDLY|NEVER]',0
;
; BSS Segment
;
        bss
menuid    ds.w 1
msgbuf    ds.w 16
INTIN:    ds.w 128
INTOUT:   ds.w 128
ADDRIN:   ds.w 128
ADDROUT:  ds.w 128
stack:    ds.b $400
resend:   ds.l 1
          end
