;
;Program Equates
;
strssp  =       0               ;RESET stack pointer
gemdos  =       1
GEM     =       2
strvec  =       4               ;RESET vector
AC_Open =       40              ;Message from GEM to open Accessary
memval  =       $420            ;Memory Validation Location
f_ver   =       $444            ;Floppy Write Verify
;
;Start Of Program
;
        text
destry: lea     resend,sp       ;Set up Internal Stack Pointer
        bsr     AES             ;Open application and get ID
        move.w  INTOUT,AP_ID
        move.w  AP_ID,INTIN     ;Register accessary in menu
        move.l  #pname,ADDRIN
        move.l  #m_regi,AESPB
        bsr     AES
        move.w  INTOUT,menuid   ;Save menu id
        bge     res000
des010: move.l  #msgbuf,ADDRIN  ;Not able to register accessary
        move.l  #e_mesa,AESPB   ;  then return to GEM always
        bsr     AES
        bra     des010
res000: bsr     go_sup          ;When first starting, clear floppy
        clr.w   f_ver           ;  write verify flag
        bsr     go_use
res010: move.l  #msgbuf,ADDRIN  ;Loop back to GEM waiting for message
        move.l  #e_mesa,AESPB   ;  to open accessary
        bsr     AES
        move.w  msgbuf,D0       ;  to open accessary
        cmpi.w  #AC_Open,D0
        bne     res010
        move.w  msgbuf+8,D0     ;If open message received, make sure its
        move.w  menuid,D1       ;  for our menu listing only.
        cmp.w   D1,D0
        bne     res010
        move.w  #3,INTIN        ;Show ALERT box asking how to reset the
        move.l  #messtr,ADDRIN  ;  the computer -
        move.l  #f_alrt,AESPB   ;FORM_Alert
        bsr     AES
        move.w  INTOUT,D5
        cmpi.w  #3,D5
        beq     res010          ;     Button #3 - don't reset
        cmpi.w  #2,D5
        beq     res200          ;     Button #2 - COLD start
        cmpi.w  #1,D5
        bne     res010
res100: bsr     go_sup          ;Enter SUPER mode first before accessing
        move.l  strssp,sp       ;  reset vectors at the very beginning
        move.l  strvec,A0       ;  of memory
        jmp     (A0)
res200: bsr     go_sup
        clr.l   memval          ;For COLD start memval must first be
        move.l  strssp,sp       ;  cleared
        move.l  strvec,A0
        jmp     (A0)
AES:    move.l  #AESPB,D1
        move.w  #$C8,D0
        trap    #GEM
        rts
go_sup: clr.l   -(sp)
        move.w  #$20,-(sp)
        trap    #gemdos
        addq.l  #6,sp
        rts
go_use: move.l  D0,-(sp)
        move.w  #$20,-(sp)
        trap    #gemdos
        addq.l  #6,sp
        rts
        text
;
; DATA Segment
;
        data
a_init:    dc.w 10,0,1,0,0
m_regi:    dc.w 35,1,1,1,0
e_mesa:    dc.w 23,0,1,1,0
f_alrt:    dc.w 52,1,1,1,0
GLOBAL:
APVERSION: dc.w 0
APCOUNT:   dc.w 0
AP_ID:     dc.w 0
APPRIVATE: dc.l 0
APPTREE:   dc.l 0
AP1RESV:   dc.l 0
AP2RESV:   dc.l 0
AP3RESV:   dc.l 0
AP4RESV:   dc.l 0
AESPB:     dc.l a_init
           dc.l GLOBAL
           dc.l INTIN
           dc.l INTOUT
           dc.l ADDRIN
           dc.l ADDROUT
pname:     dc.b    '  Reset Computer',0
messtr     dc.b    '[3][How do you want to reset|the computer and '
           dc.b    'destroy|all of your work...]'
           dc.b    '[WARMLY|COLDLY|NEVER]',0
;
; BSS Segment
;
        bss
menuid    ds.w    1
msgbuf    ds.w    16
INTIN:    ds.w 128
INTOUT:   ds.w 128
ADDRIN:   ds.w 128
ADDROUT:  ds.w 128
stack:    ds.b $200
resend:   ds.l 1
          end
